local day_length_ticks
local dusk_length_ticks
local night_length_ticks
local dawn_length_ticks
local cycle_length_ticks
local day_offset_ticks
local dusk_begin_tick
local night_begin_tick
local dawn_begin_tick
local day_begin_tick
local cycle_phase_tick
local day_lengths
local surfaces

local function compute_values()
    day_lengths = { ["nauvis"] = {
    ["day_length_ticks"] = settings.global["dayphaseadjuster-daylength"].value * 60,
    ["dusk_length_ticks"] = settings.global["dayphaseadjuster-dusklength"].value * 60,
    ["night_length_ticks"] = settings.global["dayphaseadjuster-nightlength"].value * 60,
    ["dawn_length_ticks"] = settings.global["dayphaseadjuster-dawnlength"].value * 60,
    ["cycle_length_ticks"] = 0,
    ["day_offset_ticks"] = 0,
    ["dusk_begin_tick"] = 0,
    ["night_begin_tick"] = 0,
    ["dawn_begin_tick"] = 0,
    ["day_begin_tick"] = 0,},

    ["vulcanus"] = {
    ["day_length_ticks"] = settings.global["dayphaseadjuster-vulcanus-daylength"].value * 60,
    ["dusk_length_ticks"] = settings.global["dayphaseadjuster-vulcanus-dusklength"].value * 60,
    ["night_length_ticks"] = settings.global["dayphaseadjuster-vulcanus-nightlength"].value * 60,
    ["dawn_length_ticks"] = settings.global["dayphaseadjuster-vulcanus-dawnlength"].value * 60,
    ["cycle_length_ticks"] = 0,
    ["day_offset_ticks"] = 0,
    ["dusk_begin_tick"] = 0,
    ["night_begin_tick"] = 0,
    ["dawn_begin_tick"] = 0,
    ["day_begin_tick"] = 0,},

     ["gleba"] = {
    ["day_length_ticks"] = settings.global["dayphaseadjuster-gleba-daylength"].value * 60,
    ["dusk_length_ticks"] = settings.global["dayphaseadjuster-gleba-dusklength"].value * 60,
    ["night_length_ticks"] = settings.global["dayphaseadjuster-gleba-nightlength"].value * 60,
    ["dawn_length_ticks"] = settings.global["dayphaseadjuster-gleba-dawnlength"].value * 60,
    ["cycle_length_ticks"] = 0,
    ["day_offset_ticks"] = 0,
    ["dusk_begin_tick"] = 0,
    ["night_begin_tick"] = 0,
    ["dawn_begin_tick"] = 0,
    ["day_begin_tick"] = 0,},

     ["fulgora"] = {
    ["day_length_ticks"] = settings.global["dayphaseadjuster-fulgora-daylength"].value * 60,
    ["dusk_length_ticks"] = settings.global["dayphaseadjuster-fulgora-dusklength"].value * 60,
    ["night_length_ticks"] = settings.global["dayphaseadjuster-fulgora-nightlength"].value * 60,
    ["dawn_length_ticks"] = settings.global["dayphaseadjuster-fulgora-dawnlength"].value * 60,
    ["cycle_length_ticks"] = 0,
    ["day_offset_ticks"] = 0,
    ["dusk_begin_tick"] = 0,
    ["night_begin_tick"] = 0,
    ["dawn_begin_tick"] = 0,
    ["day_begin_tick"] = 0,},

     ["aquilo"] = {
    ["day_length_ticks"] = settings.global["dayphaseadjuster-aquilo-daylength"].value * 60,
    ["dusk_length_ticks"] = settings.global["dayphaseadjuster-aquilo-dusklength"].value * 60,
    ["night_length_ticks"] = settings.global["dayphaseadjuster-aquilo-nightlength"].value * 60,
    ["dawn_length_ticks"] = settings.global["dayphaseadjuster-aquilo-dawnlength"].value * 60,
    ["cycle_length_ticks"] = 0,
    ["day_offset_ticks"] = 0,
    ["dusk_begin_tick"] = 0,
    ["night_begin_tick"] = 0,
    ["dawn_begin_tick"] = 0,
    ["day_begin_tick"] = 0,},
    }



    if script.active_mods["space-age"] == nil
    then
        surfaces = {"nauvis"}
    else
        surfaces = {"nauvis", "vulcanus", "gleba", "fulgora", "aquilo"}
    end

    -- Compute lengths after initializing from settings:
    -- Lua is apparently retarded, and doesn't have any normal loop over a simple array. You *have* to use a numeric index, for some reason.
    -- for surface of surfaces
    for surface = 1, #surfaces
    do
    day_lengths[surfaces[surface]]["cycle_length_ticks"] = day_lengths[surfaces[surface]]["day_length_ticks"] + day_lengths[surfaces[surface]]["dusk_length_ticks"] + day_lengths[surfaces[surface]]["night_length_ticks"] + day_lengths[surfaces[surface]]["dawn_length_ticks"]
    day_lengths[surfaces[surface]]["day_offset_ticks"] = day_lengths[surfaces[surface]]["day_length_ticks"] / 2
    day_lengths[surfaces[surface]]["dusk_begin_tick"] = day_lengths[surfaces[surface]]["day_offset_ticks"]
    day_lengths[surfaces[surface]]["night_begin_tick"] = day_lengths[surfaces[surface]]["dusk_begin_tick"] + day_lengths[surfaces[surface]]["dusk_length_ticks"]
    day_lengths[surfaces[surface]]["dawn_begin_tick"] = day_lengths[surfaces[surface]]["night_begin_tick"] + day_lengths[surfaces[surface]]["night_length_ticks"]
    day_lengths[surfaces[surface]]["day_begin_tick"] = day_lengths[surfaces[surface]]["dawn_begin_tick"] + day_lengths[surfaces[surface]]["dawn_length_ticks"]
    end

end
-- script.on_configuration_changed(compute_values)

local function on_init() 
    compute_values()
end
script.on_init(on_init)

local function on_load(event)
    compute_values()
end
script.on_load(on_load)


local function on_tick(event)
    
    -- "daytime" goes from 0 to 1, as a float, but noon is 0, for some damned reason, with 1 being just before noon. WTF.
    for surface = 1, #surfaces
    do
        if game.surfaces[surfaces[surface]] ~= nil then
            cycle_phase_tick = game.tick % day_lengths[surfaces[surface]]["cycle_length_ticks"]

            if cycle_phase_tick < day_lengths[surfaces[surface]]["dusk_begin_tick"] then
                -- we are in day
                game.surfaces[surfaces[surface]].daytime = (((cycle_phase_tick + day_lengths[surfaces[surface]]["day_offset_ticks"]) / day_lengths[surfaces[surface]]["day_length_ticks"]) / 2 ) - 0.25
            elseif cycle_phase_tick < day_lengths[surfaces[surface]]["night_begin_tick"] then
                -- we are in dusk
                game.surfaces[surfaces[surface]].daytime = (((cycle_phase_tick - day_lengths[surfaces[surface]]["day_offset_ticks"]) / day_lengths[surfaces[surface]]["dusk_length_ticks"]) / 5 ) + 0.25
            elseif cycle_phase_tick < day_lengths[surfaces[surface]]["dawn_begin_tick"] then
                -- we are in night
                game.surfaces[surfaces[surface]].daytime = (((cycle_phase_tick - day_lengths[surfaces[surface]]["night_begin_tick"]) / day_lengths[surfaces[surface]]["night_length_ticks"]) / 10 ) + 0.45
            elseif cycle_phase_tick < day_lengths[surfaces[surface]]["day_begin_tick"] then
                -- we are in dawn
                game.surfaces[surfaces[surface]].daytime = (((cycle_phase_tick - day_lengths[surfaces[surface]]["dawn_begin_tick"]) / day_lengths[surfaces[surface]]["dawn_length_ticks"]) / 5 ) + 0.55
            else
                -- we are in the part of day that's at 0.75 to 1.00
                game.surfaces[surfaces[surface]].daytime = (((cycle_phase_tick - day_lengths[surfaces[surface]]["day_begin_tick"]) / day_lengths[surfaces[surface]]["day_length_ticks"]) / 2 ) + 0.75
            end
        end
    end

end
script.on_event(defines.events.on_tick, on_tick)